<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Frete extends Model
{
    use HasFactory;

    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'frete_id',
        'user_id',
        'empresa',
        'origem',
        'destino',
        'tipo_carga',
        'distancia',
        'tipo_veiculo',
        'preco',
        'descricao_pagamento',
        'patrocinado',
        'tempo_publicacao',
        'url_frete',
        'contatos_whatsapp',
        'contatos_celular',
        'contatos_fixo',
        'data_cadastro',
        'data_extracao'
    ];

    /**
     * The attributes that should be cast.
     *
     * @var array
     */
    protected $casts = [
        'data_cadastro' => 'datetime',
        'data_extracao' => 'datetime',
    ];

    /**
     * Get the user that owns the frete.
     */
    public function user()
    {
        return $this->belongsTo(User::class);
    }
}
