<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class VeiculoLocalizacao extends Model
{
    use HasFactory;

    /**
     * A tabela associada com o modelo.
     *
     * @var string
     */
    protected $table = 'veiculos_localizacoes';

    /**
     * Os atributos que são atribuíveis em massa.
     *
     * @var array<int, string>
     */
    protected $fillable = [
        'veiculo_id',
        'latitude',
        'longitude',
        'cidade',
        'estado',
        'data_registro',
    ];

    /**
     * Os atributos que devem ser convertidos.
     *
     * @var array<string, string>
     */
    protected $casts = [
        'latitude' => 'decimal:8',
        'longitude' => 'decimal:8',
        'data_registro' => 'datetime',
    ];

    /**
     * Indica se os timestamps são automaticamente mantidos.
     *
     * @var bool
     */
    public $timestamps = false;

    /**
     * Obtém o veículo ao qual esta localização pertence.
     */
    public function veiculo()
    {
        return $this->belongsTo(Veiculo::class);
    }
}
